import _regeneratorRuntime from "@babel/runtime/regenerator";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { Method, Header } from '@shopify/network';
import { WebhookHeader } from './types';
export var ApiVersion;

(function (ApiVersion) {
  ApiVersion["April19"] = "2019-04";
  ApiVersion["July19"] = "2019-07";
  ApiVersion["October19"] = "2019-10";
  ApiVersion["January20"] = "2020-01";
  ApiVersion["April20"] = "2020-04";
  ApiVersion["Unstable"] = "unstable";
  ApiVersion["Unversioned"] = "unversioned";
})(ApiVersion || (ApiVersion = {}));

export function registerWebhook(_x) {
  return _registerWebhook.apply(this, arguments);
}

function _registerWebhook() {
  _registerWebhook = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref) {
    var _headers;

    var address, topic, accessToken, shop, apiVersion, response, result;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            address = _ref.address, topic = _ref.topic, accessToken = _ref.accessToken, shop = _ref.shop, apiVersion = _ref.apiVersion;
            _context.next = 3;
            return fetch("https://".concat(shop, "/admin/api/").concat(apiVersion, "/graphql.json"), {
              method: Method.Post,
              body: buildQuery(topic, address),
              headers: (_headers = {}, _defineProperty(_headers, WebhookHeader.AccessToken, accessToken), _defineProperty(_headers, Header.ContentType, 'application/graphql'), _headers)
            });

          case 3:
            response = _context.sent;
            _context.next = 6;
            return response.json();

          case 6:
            result = _context.sent;

            if (!(result.data && result.data.webhookSubscriptionCreate && result.data.webhookSubscriptionCreate.webhookSubscription)) {
              _context.next = 11;
              break;
            }

            return _context.abrupt("return", {
              success: true,
              result: result
            });

          case 11:
            return _context.abrupt("return", {
              success: false,
              result: result
            });

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _registerWebhook.apply(this, arguments);
}

function buildQuery(topic, callbackUrl) {
  return "\n    mutation webhookSubscriptionCreate {\n      webhookSubscriptionCreate(topic: ".concat(topic, ", webhookSubscription: {callbackUrl: \"").concat(callbackUrl, "\"}) {\n        userErrors {\n          field\n          message\n        }\n        webhookSubscription {\n          id\n        }\n      }\n    }\n  ");
}